//Include structures file from packer project
#include "../simple_pe_packer/structs.h"

//Create function without prologue and epilogue
void __declspec(naked) unpacker_main()
{
	//Create prologue manually
	__asm
	{
		push ebp;
		mov ebp, esp;
		sub esp, 128;
	}

	
	//Image loading address
	unsigned int original_image_base;
	//First section relative address,
	//in which the packer stores its information
	//and packed data themselves
	unsigned int rva_of_first_section;

	//These instructions are required only to
	//replace the addresses in unpacker builder with real ones
	__asm
	{
		mov original_image_base, 0x11111111;
		mov rva_of_first_section, 0x22222222;
	}
	
	//Get pointer to structure with information
	//carefully prepared by packer
	const packed_file_info* info;
	//It is stored in the beginning
	//of packed file first section
	info = reinterpret_cast<const packed_file_info*>(original_image_base + rva_of_first_section);

	//Two LoadLibraryA and GetProcAddress function prototypes typedefs 
	typedef HMODULE (__stdcall* load_library_a_func)(const char* library_name);
	typedef INT_PTR (__stdcall* get_proc_address_func)(HMODULE dll, const char* func_name);

	//Read their addresses from packed_file_info structure
	//Loader puts them there for us
	load_library_a_func load_library_a;
	get_proc_address_func get_proc_address;
	load_library_a = reinterpret_cast<load_library_a_func>(info->load_library_a);
	get_proc_address = reinterpret_cast<get_proc_address_func>(info->get_proc_address);
	
	
	//Create buffer on stack
	char buf[32];
	//user32.dll
	*reinterpret_cast<DWORD*>(&buf[0]) = 'resu';
	*reinterpret_cast<DWORD*>(&buf[4]) = 'd.23';
	*reinterpret_cast<DWORD*>(&buf[8]) = 'll';

	//Load user32.dll library
	HMODULE user32_dll;
	user32_dll = load_library_a(buf);

	//MessageBoxA function prototype typedef
	typedef int (__stdcall* message_box_a_func)(HWND owner, const char* text, const char* caption, DWORD type);

	//MessageBoxA
	*reinterpret_cast<DWORD*>(&buf[0]) = 'sseM';
	*reinterpret_cast<DWORD*>(&buf[4]) = 'Bega';
	*reinterpret_cast<DWORD*>(&buf[8]) = 'Axo';

	//Get MessageBoxA function address
	message_box_a_func message_box_a;
	message_box_a = reinterpret_cast<message_box_a_func>(get_proc_address(user32_dll, buf));

	//Hello!
	*reinterpret_cast<DWORD*>(&buf[0]) = 'lleH';
	*reinterpret_cast<DWORD*>(&buf[4]) = '!!o';

	//MessageBox call
	message_box_a(0, buf, buf, MB_ICONINFORMATION);

	//Create epilogue manually
	_asm
	{
		leave;
		ret;
	}
}